<template>
  <section rootKeyList>
    <md-app-toolbar class="md-primary" md-elevation="0">
      <img v-if="renderData.length === 0" src="/img/hourglass_color.gif" alt="tick tock tick tock">
      <md-switch v-model="showInvalid" v-if="invalidEntriesCount > 0">Show {{invalidEntriesCount}} invalid {{renderMode}}</md-switch>
    </md-app-toolbar>
    <section>


      <template v-if="renderMode === 'keys'">
        <section year v-for="yearEntry in filterKeyModeEmptySections(renderData, showInvalid)" :key="yearEntry.year">
          <p year-title v-if="filterKeyModeEmptySections(renderData, showInvalid).length > 1">{{yearEntry.year}}</p>
          <ul>
            <li v-for="entry in filterKeyMode(yearEntry, showInvalid)"
                :key="entry.id" key-entry
                @click="selectKey(entry.ID)"
                :invalid="entry.VALID !== 'Y'"
                :active="entry.ID === activeValue">{{entry.ID}}</li>
          </ul>
        </section>
      </template>


      <template v-else-if="renderMode === 'modes'">
        <section year v-for="yearEntry in filterModeModeEmptySections(renderData, showInvalid)" :key="yearEntry.year">
          <p year-title v-if="filterModeModeEmptySections(renderData, showInvalid).length > 1">{{yearEntry.year}}</p>
          <ul>
            <li v-for="modeEntry in filterModeMode(yearEntry, showInvalid)"
                :key="modeEntry.name"
                :invalid="!modeEntry.valid"><modeSelector :modeEntry="modeEntry" @modeselected="selectKey" :activeValue="activeValue"/></li>
          </ul>
        </section>
      </template>


      <template v-else-if="renderMode === 'categories'">
        <section year v-for="yearEntry in filterCategoryModeEmptySections(renderData, showInvalid)" :key="yearEntry.year">
          <p year-title v-if="filterCategoryModeEmptySections(renderData, showInvalid).length > 1">{{yearEntry.year}}</p>
          <ul>
            <li v-for="categoryEntry in yearEntry.categories" :key="categoryEntry.category" category-entry>
              <p @click="toggleCategory(categoryEntry)"><md-icon md-src="/img/md/folder_open.svg"/>{{categoryEntry.category}}</p>
              <transition name="category-content">
                <ul v-if="!categoryEntry.hidden">
                  <li v-for="modeEntry in filterModeMode(categoryEntry, showInvalid)"
                      :key="modeEntry.name"
                      :invalid="!modeEntry.valid"><modeSelector :modeEntry="modeEntry" @modeselected="selectKey" :activeValue="activeValue"/></li>
                </ul>
              </transition>
            </li>
          </ul>
        </section>
      </template>


      <p v-else>Error: invalid table setup</p>
    </section>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Prop, Watch } from 'vue-property-decorator';
import { MdSwitch } from 'vue-material/dist/components';
import { store, State } from '../../store';
import { KeyPathKey } from '../../store/editor';
import axios from '../../lib/axios';
import eventBus, { KeySavedEvent } from '../../lib/eventBus';
import modeSelector from './modeSelector.vue';

const unknownYear = '21st century';

Vue.use(MdSwitch);
@Component({
  components: {
    modeSelector,
  },
})
export default class extends Vue {
  private keyData: any = {};
  private modesData: any = null;
  private renderMode: 'keys' | 'modes' | 'categories' = 'keys';
  private renderData: any[] = [];
  private showInvalid = false;
  private invalidEntriesCount = 0;
  private table = '';

  @Prop({default: 'editor'})
  private tableSource!: 'editor' | 'compare';

  @Prop()
  private activeValue!: string;

  public created() {
    this.unwatch = store.watch(this.getTableName, tableName => this.table = tableName);
    eventBus.on('key-saved', this.onKeySaved);
    this.getKeys(this.getTableName(store.state));
  }
  public beforeDestroy() {
    this.unwatch();
    eventBus.off('key-saved', this.onKeySaved);
  }
  // tslint:disable-next-line:no-empty
  private unwatch = () => {};

  private onKeySaved(event: KeySavedEvent) {
    const match = this.keyData.rows.some(row => row.ID === event.oldKey);
    if (match) {
      this.getKeys(event.table);
    }
  }

  private getTableName(state: State): string {
    if (this.tableSource === 'editor') {
      if (state.editor.keyPath.length === 0) {
        return '';
      }
      return state.editor.keyPath[0].tableName || '';
    } else {
      return state.editor.compareTable || '';
    }
  }

  @Watch('table')
  private async getKeys(tableName: string) {
    this.renderData = [];
    this.keyData = (await store.dispatch.database('getKeys', [tableName])).data;
    if (!this.keyData.mode_column) {
      this.renderMode = 'keys';
      this.modesData = null;
      this.renderKeyMode();
    } else {
      const modeColumn = this.keyData.metaData.find(c => c.name === this.keyData.mode_column);
      const modesTableName = modeColumn.FOREIGN_TABLE_NAME;
      this.modesData = (await store.dispatch.database('getKeys', [modesTableName])).data;
      if (this.modesData.metaData.some(column => column.name === 'CATEGORY')) {
        this.renderMode = 'categories';
        this.renderCategoryMode();
      } else {
        this.renderMode = 'modes';
        this.renderModeMode(); // haha
      }
    }
  }

  private selectKey(id: string) {
    this.$emit('rootkeyselected', id);
  }

  private toggleCategory(categoryEntry) {
    categoryEntry.hidden = !categoryEntry.hidden;
  }

  private renderKeyMode() {
    const byYear = {};
    let invalidCount = 0;
    this.keyData.rows.forEach(row => {
      const year = row.YEAR || unknownYear;
      byYear[year] = byYear[year] || [];
      byYear[year].push(row);
      if (row.VALID && row.VALID !== 'Y') {
        invalidCount++;
      }
    });

    this.invalidEntriesCount = invalidCount;
    this.renderData = Object.keys(byYear).sort().reverse().map(year => {
      const allKeys = byYear[year].reverse();
      const validKeys = allKeys.filter(k => k.VALID !== 'N');
      return {
        year,
        allKeys,
        validKeys,
      };
    });
  }

  private filterKeyModeEmptySections(renderData, showInvalid: boolean) {
    return renderData.filter(yearEntry => {
      const keys = this.filterKeyMode(yearEntry, showInvalid);
      return keys.length > 0;
    });
  }

  private filterKeyMode(yearEntry, showInvalid: boolean) {
    return showInvalid ? yearEntry.allKeys : yearEntry.validKeys;
  }

  private renderModeMode() {
    const byYear = {};
    let invalidCount = 0;
    this.keyData.rows.forEach(row => {
      const mode: string = row.MODE;
      const modeRow = this.modesData.rows.find(r => r.ID === mode);
      const year: string = modeRow.YEAR || unknownYear;
      const bymode = byYear[year] = byYear[year] || {};
      if (!bymode[mode]) {
        bymode[mode] = {
          valid: modeRow.VALID !== 'N',
          name: modeRow.MODE || modeRow.ID,
          keys: [],
        };
        if (modeRow.CATEGORY) {
          bymode[mode].category = modeRow.CATEGORY;
        }
        if (!bymode[mode].valid) {
          invalidCount++;
        }
      }
      const modeEntry = bymode[mode].keys;
      modeEntry.push({
        version: 'v' + row.VERSION,
        row,
      });
    });

    this.invalidEntriesCount = invalidCount;
    this.renderData = Object.keys(byYear).sort().reverse().map(year => {
      const allModes = Object.keys(byYear[year])
                        .map(modeId => byYear[year][modeId])
                        .sort((a, b) => a.name > b.name ? 1 : -1);

      allModes.forEach(modeEntry => modeEntry.keys.sort((a, b) => {
        const aa = a.version + '';
        const bb = b.version + '';
        if (aa.length > bb.length) {
          return -1;
        } else if (aa.length < bb.length) {
          return 1;
        } else if (aa > bb) {
          return -1;
        } else {
          return 1;
        }
      }));

      return {
        year,
        allModes,
        validModes: allModes.filter(mode => mode.valid),
      };
    });
  }

  private filterModeModeEmptySections(renderData, showInvalid: boolean) {
    return renderData.filter(yearEntry => {
      const keys = this.filterModeMode(yearEntry, showInvalid);
      return keys.length > 0;
    });
  }

  private filterModeMode(entry, showInvalid: boolean) {
    return showInvalid ? entry.allModes : entry.validModes;
  }

  private renderCategoryMode() {
    this.renderModeMode();
    this.renderData = this.renderData.map(byYear => {
      const modes = byYear.allModes;
      const year = byYear.year;
      const byCategory = {};
      byYear.allModes.forEach(modeEntry => {
        const category = modeEntry.category;
        byCategory[category] = byCategory[category] || [];
        byCategory[category].push(modeEntry);
      });
      const categories = Object.keys(byCategory).map(category => {
        const allModes = byCategory[category];
        return {
          category,
          hidden: true,
          allModes,
          validModes: allModes.filter(mode => mode.valid),
        };
      });
      return {
        year,
        categories,
      };
    });
  }

  private filterCategoryModeEmptySections(renderData, showInvalid: boolean) {
    return renderData.filter(yearEntry => {
      const validCount = yearEntry.categories.reduce((count, e) =>
        count + this.filterModeMode(e, showInvalid).length, 0);
      return validCount > 0;
    });
  }
}
</script>

<style scoped lang="scss">
[rootKeyList] {
  // min-width: 250px;
  display: flex;
  flex-direction: column;
  height: 100%;
  white-space: nowrap;
  @include md-theme-property(background, primary, "primary");
  @include md-theme-property(color, text-primary, "primary");

  & > section {
    overflow-y: auto;
    scrollbar-color: md-theme(accent, "") md-theme(primary, "");
    scrollbar-width: thin;

    &::-webkit-scrollbar-track {
      background-color: md-theme(primary, "");
    }

    &::-webkit-scrollbar {
      width: 5px;
      background-color: md-theme(primary, "");
    }

    &::-webkit-scrollbar-thumb {
      background-color: md-theme(accent, "");
    }
  }

  ul {
    list-style: none;
    padding: 0;
    font-size: 1.1em;

    li {
      &[invalid] {
         @include md-theme-property(color, disabled, "primary");
      }
      &[key-entry] {
        min-height: 2.2em;
        padding: 0 10px;
        display: flex;
        align-items: center;

        &[active] {
          @include md-theme-property(background, accent, "primary");
        }
      }
    }

    &.category-content-enter-active, &.category-content-leave-active {
      transition: all .1s ease-in-out;
    }
    &.category-content-enter, &.category-content-leave-to {
      transform: translateY(-10px);
      opacity: 0;
    }

    .md-icon {
      margin: 0 .5em;
      @include md-theme-property(color, accent, "primary");
      display: inline-block;
    }
  }

  [year-title] {
    @include md-theme-property(color, disabled, "primary");
    padding: 0 20px;
    margin: 0;
  }
}
</style>
<style lang="scss">
[rootKeyList] {
  li {
    &[category-entry] {
      .md-icon svg {
        @include md-theme-property(fill, accent, "primary");
      }
    }
  }
}
</style>

